//! Constants used in rCore
#[allow(unused)]

pub const USER_STACK_SIZE: usize = 4096 * 2;
pub const KERNEL_STACK_SIZE: usize = 4096 * 2;
pub const KERNEL_HEAP_SIZE: usize = 0x20_0000;

pub const PAGE_SIZE: usize = 0x1000;
pub const PAGE_SIZE_BITS: usize = 0xc;
#[allow(unused)]
pub const THREAD_STACK_SIZE_MIN: usize = PAGE_SIZE * 4;
#[allow(unused)]
pub const SIGNAL_STACK_SIZE: usize = PAGE_SIZE;
pub const USER_HEAP_SIZE: usize = PAGE_SIZE * 64;

pub const MEMORY_START: usize = 0x80200000;

pub const MMAP_BASE: usize = 0x60000000;
#[allow(unused)]
pub const USER_STACK: usize = TRAP_CONTEXT - PAGE_SIZE;
#[allow(unused)]
pub const USER_SIGNAL_STACK: usize = USER_STACK - USER_STACK_SIZE - PAGE_SIZE;

pub const TRAMPOLINE: usize = usize::MAX - PAGE_SIZE + 1;
pub const TRAP_CONTEXT: usize = TRAMPOLINE - PAGE_SIZE;

pub use crate::board::{CLOCK_FREQ, MEMORY_END, MMIO};
